/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   clocked_seq.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_CLOCKED_SEQ_H
#define UHDM_CLOCKED_SEQ_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/BaseClass.h>

#include "sequence_expr_group.h"


namespace UHDM {
class expr;

class clocked_seq final : public BaseClass {
  UHDM_IMPLEMENT_RTTI(clocked_seq, BaseClass)
public:
  // Implicit constructor used to initialize all members,
  // comment: clocked_seq();
  virtual ~clocked_seq() final = default;

  virtual const BaseClass* VpiParent() const final { return vpiParent_; }

  virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; return true; }

  virtual bool VpiFile(const std::string& data) final;

  virtual const std::string& VpiFile() const final;

  virtual unsigned int UhdmId() const final { return uhdmId_; }

  virtual bool UhdmId(unsigned int data) final { uhdmId_ = data; return true; }

  const expr* VpiClockingEvent() const { return vpiClockingEvent_; }

  bool VpiClockingEvent(expr* data) { vpiClockingEvent_ = data; return true; }

  const any* VpiSequenceExpr() const { return vpiSequenceExpr_; }

  bool VpiSequenceExpr(any* data) { if (!sequence_expr_groupGroupCompliant(data)) return false; vpiSequenceExpr_ = data; return true; }

  virtual unsigned int VpiType() const final { return vpiClockedSeq; }

  virtual clocked_seq* DeepClone(Serializer* serializer, ElaboratorListener* elaborator, BaseClass* parent) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int property) const override;

  virtual int Compare(const BaseClass* const other, AnySet& visited) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmclocked_seq; }

protected:
  void DeepCopy(clocked_seq* clone, Serializer* serializer,
                ElaboratorListener* elaborator, BaseClass* parent) const;

private:
  BaseClass* vpiParent_ = nullptr;

  SymbolFactory::ID vpiFile_ = 0;

  unsigned int uhdmId_ = 0;

  expr* vpiClockingEvent_ = nullptr;

  any* vpiSequenceExpr_ = nullptr;
};


typedef FactoryT<clocked_seq> clocked_seqFactory;


typedef FactoryT<std::vector<clocked_seq *>> VectorOfclocked_seqFactory;

}  // namespace UHDM

#endif
