/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   hier_path.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_HIER_PATH_H
#define UHDM_HIER_PATH_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/variables.h>

#include "actual_group.h"


namespace UHDM {


class hier_path final : public variables {
  UHDM_IMPLEMENT_RTTI(hier_path, variables)
public:
  // Implicit constructor used to initialize all members,
  // comment: hier_path();
  virtual ~hier_path() final = default;

  virtual const BaseClass* VpiParent() const final { return vpiParent_; }

  virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; return true; }

  virtual bool VpiFile(const std::string& data) final;

  virtual const std::string& VpiFile() const final;

  virtual unsigned int UhdmId() const final { return uhdmId_; }

  virtual bool UhdmId(unsigned int data) final { uhdmId_ = data; return true; }

  VectorOfany* Path_elems() const { return path_elems_; }

  bool Path_elems(VectorOfany* data) { if (!actual_groupGroupCompliant(data)) return false; path_elems_ = data; return true; }

  const any* Root_value() const { return root_value_; }

  bool Root_value(any* data) { if (!actual_groupGroupCompliant(data)) return false; root_value_ = data; return true; }

  virtual unsigned int VpiType() const final { return vpiHierPath; }

  virtual hier_path* DeepClone(Serializer* serializer, ElaboratorListener* elaborator, BaseClass* parent) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int property) const override;

  virtual int Compare(const BaseClass* const other, AnySet& visited) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmhier_path; }

protected:
  void DeepCopy(hier_path* clone, Serializer* serializer,
                ElaboratorListener* elaborator, BaseClass* parent) const;

private:
  BaseClass* vpiParent_ = nullptr;

  SymbolFactory::ID vpiFile_ = 0;

  unsigned int uhdmId_ = 0;

  VectorOfany* path_elems_ = nullptr;

  any* root_value_ = nullptr;
};


typedef FactoryT<hier_path> hier_pathFactory;


typedef FactoryT<std::vector<hier_path *>> VectorOfhier_pathFactory;

}  // namespace UHDM

#endif
